C Interface routines C++ -> Fortran
      SUBROUTINE ptx(PX, PY, CHARS)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_CHAR, C_NULL_CHAR
      REAL PX, PY
      CHARACTER*(*) CHARS
      CALL ptx_c(PX, PY, CHARS//C_NULL_CHAR)
      END
      
      SUBROUTINE ptx3(PX, PY, PZ, TDX, TDY, TDZ, CHARS) 
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_CHAR, C_NULL_CHAR
      REAL PX, PY, PZ, TDX, TDY, TDZ
      CHARACTER*(*) CHARS
      CALL ptx3_c(PX, PY, PZ, TDX, TDY, TDZ, CHARS//C_NULL_CHAR)
      END
     
      SUBROUTINE strnam (SEG, NAM)
		USE ISO_C_BINDING,  ONLY: C_INT,  C_CHAR, C_NULL_CHAR
      CHARACTER *8 grstgc
      EXTERNAL grstgc
C      integer(c_int), value :: SEG 
      integer SEG 
      CHARACTER *8 NAM
C      CHARACTER *12 NAMR
C      WRITE(*,*) 'In strnam SEG: ' , SEG
      NAM = grstgc(SEG)
C      NAMR = NAM//C_NULL_CHAR
	
C		WRITE(*,*) 'In strnam NAM: ' , NAM
      END
      SUBROUTINE hplopt(CHARS, N)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_CHAR, C_NULL_CHAR
      EXTERNAL hplopt_c
      CHARACTER*(*) CHARS
C      WRITE (*,*) CHARS(1:4*N)
      CALL hplopt_c( CHARS(1:4*N)//C_NULL_CHAR, N)
      END
      
		SUBROUTINE itx(X, Y, CHARS)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_CHAR, C_NULL_CHAR
      EXTERNAL itx_c
      CHARACTER*(*) CHARS
      REAL X, Y
C      WRITE (*,*) 'itx X ', X, ' Y ' , Y, CHARS
      CALL itx_c(X, Y, CHARS//C_NULL_CHAR)
      END
      
      SUBROUTINE hpltab(ID, NPARS, PARS, CHARS)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_CHAR, C_NULL_CHAR
      EXTERNAL hpltab_c
      INTEGER ID, NPARS
      REAL PARS(*)
      CHARACTER*(*) CHARS
C      WRITE (*,*) CHARS(1:4*N)
      CALL hpltab_c(ID, NPARS, PARS, CHARS//C_NULL_CHAR)
      END
      
      SUBROUTINE hpltit(CHARS)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_CHAR, C_NULL_CHAR
      EXTERNAL hpltit_c
      CHARACTER*(*) CHARS
C      WRITE (*,*) CHARS(1:4*N)
      CALL hpltit_c(CHARS//C_NULL_CHAR)
      END
      
!       SUBROUTINE hplint(I)
!       WRITE (*,*)'hplint', I
!       END
! 		SUBROUTINE iginit(I)
!       WRITE (*,*)'iginit', I
!       END
     
C_________________________________________________________________________
      
      SUBROUTINE odpbkx(IDAT,NIMOV,CIFOR,CIDAT,RDAT,NRMOV,CRFOR,CRDAT)
      USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_CHAR, C_NULL_CHAR
      EXTERNAL odpbkx_c
      INTEGER NIMOV,NRMOV,IDAT(*)
      REAL    RDAT(*)
      CHARACTER*(*) CIFOR, CIDAT, CRFOR, CRDAT

      CALL odpbkx_c(IDAT,NIMOV,CIFOR(1:4*NIMOV)//C_NULL_CHAR,
     1              CIDAT(1:4*NIMOV)//C_NULL_CHAR,
     1              RDAT,NRMOV,CRFOR(1:4*NRMOV)//C_NULL_CHAR,
     1              CRDAT(1:4*NRMOV)//C_NULL_CHAR)
      END
     
C_________________________________________________________________________
      
      SUBROUTINE rsevct()
      
C     reset event counters in IRTRIG to allow for "get previous event"
c     this is a new routine for easy access to the FORTRAN common

      INTEGER    IREVPR,IRSTOP,IRTRIG,IRDEBG,IODPBL,IMONIT,IZVERI,
     +           IZLOGL,IRUFST,IEVFST,IRULST,IEVLST,ITRYMX,
     +           NCENT ,NECAL ,NHCAL ,NMUON ,NFORW ,NPACK ,NODBLK,
     +           LCENT ,LECAL ,LHCAL ,LMUON ,LFORW ,LPACK ,LODBLK,
     +           NRERUN,LRERUN,LEVKEY,LREKEY,LGEKEY,LCALRD,LCALWT,
     +           ICMAIN,NEVTRP,NTOTRP,ITTBAT,ITRBAT,IFIBAT,ISCBAT,
     +           IDDBAT,IDUBAT,IFCNST,IFSCAN,IFBOOK,IFDROP,IFUPDT,
     +           INDROP,ICDATE,ICTIME,NSTOP ,KEEPJU,ILLBAT,ILABAT,
     +           ISDATE,ISTIME,IFODSI,IFNOEU,NOWRIT
      INTEGER    NSLCMI,NSLCMA,NSLMMI,NSLMMA,ISLRUN,ISLEVT,IFSLON
      INTEGER    NPFILE,NPFATF,NAMLEN,NAMLWO,NPAFIL,NPAFAT,NPACAT,
     +           NPCATA,NPCFIL,NPACFI,NPGDEV,NPAGDE,NPADAD,NPDADL,
     +           LFITYP,LFIDIR,LFIUNI,LFILRE,LFIFCH,LFIDCH,LFINAM,
     +           LCFTYP,LCFDIR,LCFUNI,LCFLRE,LCFFCH,LCFDCH,LCFNAM,
     +           LFATYP,LFADIR,LFAUNI,LFADCH,LFANAM,LCAUNI,LCANAM,
     +           LDATYP,LDADIR,LDAUN1,LDAUN2,LDAOPT,LDANAM,
     +           LFATLU,LFATLO,LFATLW,LFATL1,LFATL2,
     +           LNADIR,LNAUN1,LNAUN2,LNAOPT,LNANAM,NPANAN,NPNANO,
     +           LEVDIR,LEVUN1,LEVUN2,LEVUN3,LEVOPT,LEVNAM,
     +           NPAEVT,NPEVTL,
     +           LMNDIR,LMNUNI,LMNOPT,LMNNAM,NPAMAS,NPMAST,
     +           LNDEVI,LTYPDE,LDEVNA,
     +           IPHONE,NPHONE,LUFONE,LFOOPT,IUNITU,NUNITU, MAXSEL
      INTEGER    MSHDSL, MSANYS,ISEKEY
      INTEGER NTRYMX,  MSHDVE
      REAL       ESLEMI,ESLEMA,ESLHMI,ESLHMA
      REAL       RTIMST,RTIMSF,RFZLIM,RTIMSI,RTIMSE
      LOGICAL    FATFIL,FFERRO,LMEMIN,LMEMOU
      PARAMETER (NAMLEN = 80,NAMLWO = NAMLEN/4,
     +           NPAFIL =  6,NPFILE = NPAFIL+NAMLWO,
     +           NPACFI =  6,NPCFIL = NPACFI+NAMLWO,
     +           NPAFAT =  4,NPFATF = NPAFAT+NAMLWO,
     +           NPADAD =  5,NPDADL = NPADAD+NAMLWO,
     +           NPACAT =  1,NPCATA = NPACAT+NAMLWO,
     +           NPAGDE =  2,NPGDEV = NPAGDE+NAMLWO,
     +           NPANAN =  4,NPNANO = NPANAN+NAMLWO,
     +           NPAEVT =  5,NPEVTL = NPAEVT+NAMLWO,
     +           NPAMAS =  3,NPMAST = NPAMAS+NAMLWO,
     +           NPHONE = 10,NUNITU = 10, MAXSEL=10)
      COMMON/RCNTRL/IREVPR,IRSTOP,IRTRIG(3),IRDEBG(4),IODPBL(3),
     +       IMONIT,IZVERI,IZLOGL,IRUFST,IEVFST,IRULST,IEVLST,ITRYMX,
     +       NCENT ,NECAL ,NHCAL ,NMUON ,NFORW ,NPACK ,NODBLK,
     +       LCENT(20),LECAL(20),LHCAL(20),LMUON(20),LFORW(20),
     +       LPACK(20),LODBLK(20),NRERUN,LRERUN(20),LEVKEY(4),
     +       LREKEY(3),LGEKEY(2),LCALRD(46),LCALWT(46),ICMAIN,
     +       RTIMST,RTIMSF,RFZLIM,RTIMSI,RTIMSE,NEVTRP,NTOTRP,ITTBAT,
     +       ITRBAT,IFIBAT,ISCBAT,IDDBAT,IDUBAT,IFCNST,IFSCAN,IFBOOK,
     +       IFDROP,IFUPDT,INDROP,NSLCMI,NSLCMA,ESLEMI,ESLEMA,ESLHMI,
     +       ESLHMA,NSLMMI,NSLMMA,ISLRUN,ISLEVT,IFSLON,ICDATE,ICTIME,
     +       NSTOP,FATFIL,FFERRO,LMEMIN,LMEMOU,LFITYP,LFIDIR,LFIUNI,
     +       LFILRE,LFIFCH,LFIDCH,LFINAM(NAMLWO),LCFTYP,LCFDIR,LCFUNI,
     +       LCFLRE,LCFFCH,LCFDCH,LCFNAM(NAMLWO),LFATYP,LFADIR,LFAUNI,
     +       LFADCH,LFANAM(NAMLWO),LDATYP,LDADIR,LDAUN1,LDAUN2,LDAOPT,
     +       LDANAM(NAMLWO),LCAUNI,LCANAM(NAMLWO),LFATLU,LFATLO,
     +       LFATLW,LFATL1,LFATL2,LNADIR,LNAUN1,LNAUN2,LNAOPT,
     +       LNANAM(NAMLWO),LEVDIR,LEVUN1,LEVUN2,LEVUN3,LEVOPT,
     +       LEVNAM(NAMLWO),LMNDIR,LMNUNI,LMNOPT,LMNNAM(NAMLWO),
     +       LNDEVI,LTYPDE,LDEVNA(NAMLWO),IPHONE(NPHONE),LUFONE,LFOOPT,
     +       IUNITU(NUNITU),KEEPJU,ILLBAT,ILABAT,ISDATE,ISTIME,IFODSI
     
      IRTRIG(1) =       0
      IRTRIG(2) =10000000
      IRTRIG(3) =       1
      END

C_______________________________________________________________________________________

      SUBROUTINE IGQWK(IWKID,PNAME,RVAL)
* Attributes list
*
* hiatt.inc
*
*CMZ :  1.23/06 20/11/95  16.43.50  by  O.Couet
*-- Author :
      INTEGER INTR,IWTYPE,IDID,IDTY,ILOPWK(10),IWTYL(10),INOPWK
     +,       IWINID(10),IPICT,ICLIP,NT0PRI,IPLCI,ILN,IPMCI,IMK,IFACI
     +,       IFAIS,IFASI,ITXCI,ITXALG,IFTPR,INPASS,IBORD,INLINE
     +,       INTATT(17),IFONT,IPREC,ITXALH,ITXALV,IDIM,INBCOL,IZBUF
      REAL XRATIO,YRATIO,RWXMIN,RWXMAX,RWYMIN,RWYMAX,RVXMIN,RVXMAX
     +,    RVYMIN,RVYMAX,RDWXMI,RDWXMA,RDWYMI,RDWYMA,RDVXMI,RDVXMA
     +,    RDVYMI,RDVYMA,RMDSX,RMDSY,XWKSIZ(10),YWKSIZ(10),WKMAX(10)
     +,    XWKR(10),YWKR(10),XWKW1(10),YWKW1(10),XWKV1(10),YWKV1(10)
     +,    XWKW2(10),YWKW2(10),XWKV2(10),YWKV2(10),REDIT,RMKSC,RLWSC
     +,    RBSL,RANGLE,RCHH,RCSHIF,RBOF,RBWD,RAWL,RTMS,RALH,RALD
     +,    REAATT(18),RCHUX,RCHUY
       LOGICAL ACWKFL(10),NODRFL(10)
      COMMON /HIATT/ INTR,XRATIO,YRATIO
     +,RWXMIN,RWXMAX,RWYMIN,RWYMAX,RVXMIN,RVXMAX,RVYMIN,RVYMAX
     +,RDWXMI,RDWXMA,RDWYMI,RDWYMA,RDVXMI,RDVXMA,RDVYMI,RDVYMA
     +,RMDSX ,RMDSY ,IWTYPE,IDID  ,IDTY
     +,ILOPWK,ACWKFL,NODRFL,IWTYL ,INOPWK
     +,XWKSIZ,YWKSIZ,WKMAX ,IWINID,XWKR  ,YWKR
     +,XWKW1 ,YWKW1 ,XWKV1 ,YWKV1
     +,XWKW2 ,YWKW2 ,XWKV2 ,YWKV2
     +,IPICT ,ICLIP ,REDIT,NT0PRI
     +,RMKSC ,RLWSC ,RBSL  ,RANGLE,RCHH  ,RCSHIF,RBOF  ,RBWD
     +,RAWL  ,RTMS  ,RALH  ,RALD  ,REAATT
     +,IPLCI ,ILN   ,IPMCI ,IMK   ,IFACI ,IFAIS ,IFASI ,ITXCI
     +,ITXALG,IFTPR ,INPASS,IBORD ,INLINE,INTATT
     +,IFONT ,IPREC ,ITXALH,ITXALV,RCHUX ,RCHUY
     +,IDIM  ,INBCOL,IZBUF

      CHARACTER*(*) PNAME
      RMDSX = 1.
      RMDSY = 1.
      IF(PNAME(1:4).EQ.'ACTI')THEN
         RVAL = 1.
      ENDIF
      IF(PNAME(1:4).EQ.'OPEN')THEN
         RVAL = 1.
      ENDIF
      END
C_______________________________________________________________________________________
*
      SUBROUTINE IRQLC(IWKIDI,LCN,ISTATI,ITNRI,XLOC,YLOC)
      ENTRY      GRQLC(IWKIDI,LCN,ISTATI,ITNRI,XLOC,YLOC)
*.===========>
*.
*.   This routine returns the graphic cursor position in WC space in
*. XLOC and YLOC. The same position in the NDC space is available in
*. RQUEST(11) and RQUEST(12). The normalization tranformation number
*. is returned in TNR. After a call to IRQLC the window coordinates
*. are available in RQUEST(20), RQUEST(21), RQUEST(22), and RQUEST(23).
*. The viewport coordinates are available in RQUEST(30), RQUEST(31),
*. RQUEST(32), and  RQUEST(33). This routine computed the XLOC and YLOC
*. value according to value of the REDIT factor, but the value of
*. RQUEST(11) and RQUEST(12) do not care about the value of REDIT. The
*. REDIT factor is usefull for the graphics editor and the menu mode of
*. KUIP.
*.   The values of XLOC and YLOC are computed with the parameters stored
*. in the NT storage (HINT) if ZEBRA is not used, or if there no
*. displayed picture. If an HIGZ picture is displayed, only the NT
*. existing in this picture are used to compute the values of XLOC and
*. YLOC.
*.   This routine can work in two modes :
*.    - The REQUEST mode where a "Button_Press" event is necesary to get
*.      the cursor position.
*.    - The SAMPLE mode where only a move of the mouse is enough to get
*.      the cursor position.
*.
*. _Input parameters:
*.
*.  INTEGER IWKIDI : Workstation identifier .
*.  INTEGER LCN    : Input device number .
*.                   If LCN>10 then LCN=10*IPET+LNDNR
*.
*.                 LCN=10 tracking cross
*.                 LCN=20 cross-hair
*.                 LCN=30 rubber circle
*.                 LCN=40 rubber band
*.                 LCN=50 rubber rectangle
*.                 LCN=99 the screen coordinates are taken
*.                        in XLOC and YLOC (X11 only).
*.
*.                 LCN>0  request mode
*.                 LCN<0  sample mode
*.
*. _Output parameters:
*.
*.  INTEGER ISTATI : Return status: 0=BREAK, 1=OK .
*.  INTEGER ITNRI  : Normalization transformation number .
*.  REAL XLOC YLOC : Cursor position in WC space .
      EXTERNAL irqlc_c
      COMMON /QUEST/ IQUEST(100)
      DIMENSION RQUEST(100)
      EQUIVALENCE (IQUEST(1),RQUEST(1))
      INTEGER istat
      REAL x, y
		CALL irqlc_c(istat, x, y)
      XLOC = x
      YLOC = y
      ITNRI = 0
      ISTATI = istat
*      WRITE (*,*) '----- IRQLC: ', ISTATI, XLOC, YLOC
      IQUEST(1) = 0
      RQUEST(11) = XLOC
      RQUEST(12) = YLOC
      RQUEST(20)=0.
      RQUEST(21)=1.
      RQUEST(22)=0.
      RQUEST(23)=1.
      RQUEST(30)=0.
      RQUEST(31)=1.
      RQUEST(32)=0.
      RQUEST(33)=1.
      END