class graphics : public TObject
{
public:
   graphics() {};
   ~graphics() {};
    void draw();
    void init(int kwtygr = 8887, int kwtyku = 0, int kwtydz = 0);
    void dzdisp(const char * ctop = "REV", int numid = 0, const char * mtyp = "POST");
    void dzddiv(const char * cdiv = "IRODIV", const char * mtyp = "POST");
    void highlight(const char * cobj = "CTRK", int inum = 0, int icol = -1, float lwscf = 4, int inumb = 1);
    void dedx(int itrk = 0, float dedxlo = 5, float dedxhi = 55);
    void btof(int itrk = 0, float plo = 0, float phi = 3, float betahi = 0, float betalo = 1.3999999761581421);
    void siroll(int iladd = 0, int iflag = 0, float zmin = -9, float zmax = 9, float phmin = 0, float phmax = 6.2831997871398926);
    void lego(const char * name = "ALL", float theta = 45, float phi = 45, const char * iopr = "LINZ");
    void lego2(int itrack = 0, float dtheta = 0.10000000149011612, float phi = 20);
    void caption(const char * text = "OPAL", float x = 0.5, float y = 0.89999997615814209, float size = 0.029999999329447746, float theta = 0, int ifont = 1, int icolo = 1);
    void odtosi(const char * csi = "SI", const char * ccx = "CX");
    void combine(int ntrk = 2, int itrk1, float amas1 = 0.13956999778747559, int itrk2, float amas2 = 0.13956999778747559, int itrk3, float amas3 = 0.13956999778747559, int itrk4, float amas4 = 0.13956999778747559, int itrk5, float amas5 = 0.13956999778747559);
    void user(const char * cuser = "");
    void call(const char * cuser = "mygrope.f");
    void comis();
};
class jets : public TObject
{
public:
   jets() {};
   ~jets() {};
    void algorithm(const char * type = "CONE");
    void parameters();
    void number();
};
class \set : public TObject
{
public:
   \set() {};
   ~\set() {};
    void linestyle(const char * option = "", const char * typest = "SOLID", float width = 0.5, int coli = 1);
    void markerstyle(const char * option = "", const char * typest = "XMARK", float width = 0.5, int coli = 1);
    void textstyle(const char * option = "", int font = 0, const char * prec = "CHARACT", float expans = 1, float spacin = 0, int coli = 1, float height = 20);
    void fillareastyle(const char * option = "ALL", const char * style = "SOLID", int styli = 3045, int coli = 1);
    void colour(int index = 9, float red = 0, float green = 0, float blue = 0);
    void revvid(int index = 1);
    void geom(const char * idet = "", int iflag, int isect = 0);
    void hits(const char * idet = "", int iflag, int isect = 0);
    void reconstruction(const char * idet = "", int iflag, int isect = 0);
    void dst(const char * iblk = "", int iflag);
    void status(const char * iflag = "ON");
    void axes(const char * iflag = "ON");
    void scale(const char * iflag = "ON");
    void header(const char * iflag = "ON");
    void background(const char * iflag = "OFF");
    void logo(const char * iflag = "ON");
    void file(const char * iflag = "ON");
    void fillbox(int igrfil = 0, const char * igrfed = "ON", int igrisi = 3045);
    void primary_vertex(const char * type = "OD");
    void autogo(const char * goflag = "ON");
    void thetacut(float thetamin = 0, float thetamax = 0, const char * scope = "ALL");
    void momentumcut(float pmin = 0, const char * scope = "ALL");
    void d0cut(float d0max = 0);
    void z0cut(float z0max = 0);
    void wwcuts(const char * wwcuts = "ON");
    void dscale();
    void perspective(const char * ippers = "ON", float dist = 0);
    void electron(const char * lide = "ON");
    void muon(const char * lidmu = "ON");
    void gammaconv(const char * lidgc = "ON");
    void lambda(const char * lidl = "ON");
    void kshort(const char * lidk = "ON");
    void higz_windows(const char * display = "LEGO", int kwid = 0);
    void higz_auto(const char * display = "LEGO", const char * onoff = "ON");
    void pretty();
    void pretty2();
    void pretty3();
    void save_attributes(const char * filename = "mysave.kumac");
};
class \reset : public TObject
{
public:
   \reset() {};
   ~\reset() {};
    void options();
    void linestyle(const char * plname = "ALL");
    void markerstyle(const char * pmname = "ALL");
    void textstyle(const char * txname = "ALL");
    void all();
};
class \mode : public TObject
{
public:
   \mode() {};
   ~\mode() {};
    void threedim();
    void twodim(const char * view1 = "XY", const char * view2 = "SIDE", const char * view3 = "ZOOM");
};
class \show : public TObject
{
public:
   \show() {};
   ~\show() {};
    void structures();
    void linestyle(const char * plname = "ALL");
    void markerstyle(const char * pmname = "ALL");
    void textstyle(const char * txname = "ALL");
    void fillareastyle(const char * faname = "ALL");
    void geom(const char * idet = "ALL");
    void hits(const char * idet = "ALL");
    void reconstruction(const char * idet = "ALL");
};
class \view : public TObject
{
public:
   \view() {};
   ~\view() {};
    void spin();
    void wobble();
    void rotate();
    void up(float dy = 0.20000000298023224);
    void down(float dy = 0.20000000298023224);
    void left(float dx = 0.20000000298023224);
    void right(float dx = 0.20000000298023224);
    void forward(float dz = 0.20000000298023224);
    void backward(float dz = 0.20000000298023224);
    void in(float factor = 1.5);
    void out(float factor = 1.5);
    void horizontal(float angle = 10);
    void vertical(float angle = 10);
    void normal(float angle = 10);
    void entire();
    void xy();
    void xz();
    void yz();
    void end();
    void side(int iside = 0);
    void sliders(float horiz = 0, float vert = 0, float normal = 0, float pan_x = 0, float pan_y = 0, float zoom = 0);
    void zoom();
    void zbox();
    void go();
    void metafile(const char * mtyp = "POST");
    void pick();
    void ppick();
};
class \phigs : public TObject
{
public:
   \phigs() {};
   ~\phigs() {};
    void menu(float timout = -1);
    void define();
    void undefine();
    void filter();
};
class \mc : public TObject
{
public:
   \mc() {};
   ~\mc() {};
    void primtrk();
    void dataprt(int trackn = 0);
    void fragmen(int drawop = 0);
    void phqdisp(int drawop = 0);
    void mcodfit(int mctrk);
    void odmcfit(int odtrk);
};
class \\ww : public TObject
{
public:
   \\ww() {};
   ~\\ww() {};
    void wwdefaults(const char * ecm = "184");
};
class set : public TObject
{
public:
   set() {};
   ~set() {};
    void quality_cuts(const char * qset = "General");
};
class \show : public TObject
{
public:
   \show() {};
   ~\show() {};
    void quality_cuts(const char * qset = "current");
