#ifndef TPOL3D
#define TPOL3D
#include "TPolyLine3D.h"
#include "TPolyMarker3D.h"

class TPol3D : public TPolyLine3D {
	
private:
	Int_t fStrNr;
	Int_t fElmId;
	TString fName;
	TString fTitle;
public:
	TPol3D() {};
	virtual ~TPol3D();
	TPol3D(Int_t n, Float_t *x, Float_t *y, Float_t *z);
	void SetStrNr(Int_t seg) { fStrNr = seg; };
	void SetElmId(Int_t id) { fElmId = id; };
	Int_t GetStrNr() { return fStrNr; };
	Int_t GetElmId() { return fElmId; };
	void PrintData();      //*MENU*
	void PrintDataTerse();      //*MENU*
	void PrintDataDocumented();      //*MENU*
	void SetName(const char * name) {fName = name;};   //*MENU*   
	const char * GetName() const {return fName.Data();};      
	void SetTitle(const char * name) {fTitle = name;}; //*MENU*     
	const char * GetTitle() const {return fTitle.Data();};      
	ClassDef (TPol3D, 0)
};
#endif