#include "TPad.h"
#include "TPol3Dtext.h"
#include "TText3D.h"
#include "TString.h"
#include <iostream>

ClassImp(TPol3Dtext)

TPol3Dtext::TPol3Dtext(Int_t n, TText3D *text)
				:  TPolyLine3D(n) , fText(text)
{
}
;
TPol3Dtext::~TPol3Dtext()
{}
;
const char * TPol3Dtext::GetText() const {
	return fText->GetText();
};            
void TPol3Dtext::SetText(const char * text) {
	fText->SetText(text); 
	fText->Compute(); 
	fText->Paint();
	gPad->Modified();
};

