static const Char_t rope_guidance[] = 
"ROPE interactive commands: main menu\n\
";

static const Char_t TRIG_guidance[] = 
"Get a new event, process NPROC if requested with PROCESS ON.\n\
";

static const Char_t SKIP_guidance[] = 
"Skip N events, get N+1 th.\n\
Process NPROC if requested with PROCESS ON.\n\
";

static const Char_t GOTO_guidance[] = 
"With option DATA or MCARLO:\n\
Get event IEVGET of run IRUGET for data or MC from shift-server\n\
With option HOTLINE:\n\
if run# =   0: get latest hotline run events\n\
if event# = 0: get next event found\n\
With option CURRENT:\n\
Get event in data files defined by FFREAD cards, or interactively.\n\
";

static const Char_t EVFIND_guidance[] = 
"With option DATA or MCARLO:\n\
Get event IEVGET of run IRUGET for data or MC from shift-server\n\
With option HOTLINE:\n\
if run# =   0: get latest hotline run events\n\
if event# = 0: get next event found\n\
With option CURRENT:\n\
Get event in data files defined by FFREAD cards, or interactively.\n\
";

static const Char_t PROCESS_guidance[] = 
"Set ON/OFF the event processing folowing TRIG/SKIP/GOTO.\n\
";

static const Char_t RIOSEL_guidance[] = 
"Select output units: LUN = 0 --> all units selected.\n\
";

static const Char_t ROWOUT_guidance[] = 
"Write to selected output units.\n\
";

static const Char_t ROBAT_guidance[] = 
"Run ROPE according to FFREAD cards.\n\
";

static const Char_t DIVERT_guidance[] = 
"Divert printed output to a file. Use option: "TERMINAL" to\n\
close file and use screen again.\n\
>Parameters\n\
CWHERE  'Where to divert (FILE/TERM)' C D='TERMINAL' R='TERMINAL,FILE'\n\
CFNAME  'File name'                   C D='rope.printout'\n\
";

static const Char_t REWIND_guidance[] = 
"Rewind input (disk file) to acces previous events.\n\
";

static const Char_t VERSION_guidance[] = 
"Print versions of available processes.\n\
";

static const Char_t FILE_guidance[] = 
"Open a new file for input or output.\n\
When an output file has been defined, use the command ROWOUT to\n\
write out the current event.\n\
";

static const Char_t DADFILE_guidance[] = 
"Open a new dadlist for input.\n\
";

static const Char_t EVTFILE_guidance[] = 
"Open a new eventlist for input.\n\
";

static const Char_t INPUT_guidance[] = 
"Open a new file for input or output.\n\
This command is obsolete, please use ROFILE instead\n\
";

static const Char_t INPUT_guidance[] = 
"Set/print cut parameters, rerun selection code (ROCHSE)\n\
";

static const Char_t Rerun_guidance[] = 
"Rerun "chargino" classification.\n\
";

static const Char_t Print_guidance[] = 
"Print cut parameters + values\n\
";

static const Char_t Print_guidance[] = 
"Set cut parameters\n\
";

static const Char_t Tracks_guidance[] = 
"Track quality criteria\n\
>Parameters\n\
CHTRQU1 'minimal number of CJ hits'       R D=20.\n\
CHTRQU2 '1/(fract of max. poss CJ hits)'  R D=2.\n\
CHTRQU3 'd0 cut'                          R D=5.\n\
CHTRQU4 'z0 cut'                          R D=40.\n\
CHTRQU5 'radius of first meas hit in CJ'  R D=60.\n\
CHTRQU6 'Chi^2/DGF in r-phi'              R D=999.\n\
CHTRQU7 'Chi^2/DGF in s-z'                R D=999.\n\
CHTRQU8 'transverse momentum of track'    R D=0.05\n\
CHTRQU9 'Maximal momentum / EBEAM'        R D=9999.9\n\
";

static const Char_t ECAL_guidance[] = 
"ECAL quality criteria quality criteria\n\
>Parameters\n\
CHECQU1 'min raw energy in EB cl' R D=0.1\n\
CHECQU2 'min raw energy in EE cl' R D=0.2\n\
CHECQU3 'min nr of blocks in EE cluste' R D=2.0\n\
";

static const Char_t LooseGen_guidance[] = 
"cut values for loose general acoplanar selection\n\
>Parameters\n\
CHSEL1_1 'Min energy in both hemispheres'    R D=1.0\n\
CHSEL1_2 'Max energy in FD'                  R D=2.0\n\
CHSEL1_3 'Min number of good charged tracks' R D=2.0\n\
CHSEL1_4 'Visible Energy / sqrt(s)'          R D=0.08\n\
CHSEL1_5 'Acoplanarity angle'                R D=10.0\n\
CHSEL1_6 'Scale for corr with E_vis'         R D=0.0\n\
CHSEL1_7 '| cos(theta_Pmiss) |'              R D=0.9\n\
CHSEL1_8 '| cos(theta_jet_max) |!DUMMY!'     R D=9999.9\n\
CHSEL1_9 '| cos(theta_thrust) |'             R D=9999.9\n\
CHSEL1_0 'Energy fract in forward region'    R D=9999.9\n\
";

static const Char_t TightGen_guidance[] = 
"cut values for tight general acoplanar selection\n\
>Parameters\n\
CHSET1_1 'Min energy in both hemispheres'    R D=1.0\n\
CHSET1_2 'Max energy in FD'                  R D=2.0\n\
CHSET1_3 'Min number of good charged tracks' R D=2.0\n\
CHSET1_4 'Visible Energy / sqrt(s)'          R D=0.1\n\
CHSET1_5 'Acoplanarity angle'                R D=20.0\n\
CHSET1_6 'Scale for corr with E_vis'         R D=1.0\n\
CHSET1_7 '| cos(theta_Pmiss) |'              R D=0.9\n\
CHSET1_8 '| cos(theta_jet_max) |!DUMMY!'     R D=9999.9\n\
CHSET1_9 '| cos(theta_thrust) |'             R D=0.7\n\
CHSET1_0 'Energy fract in forward region'    R D=9999.9\n\
";

static const Char_t LooseLow_guidance[] = 
"cut values for loose low multiplicity selection\n\
>Parameters\n\
CHSEL2_1 'Min energy in both hemispheres'    R D=1.0\n\
CHSEL2_2 'Max energy in FD'                  R D=2.0\n\
CHSEL2_3 'Min number of good charged tracks' R D=2.0\n\
CHSEL2_4 'Max number of good charged tracks' R D=10.0\n\
CHSEL2_5 'Visible Energy / sqrt(s)'          R D=-1.\n\
CHSEL2_6 'Acoplanarity angle'                R D=10.0\n\
CHSEL2_7 '| cos(theta_Pmiss) |'              R D=0.9\n\
CHSEL2_8 '| cos(theta_jet_max) |!DUMMY!'     R D=9999.9\n\
CHSEL2_9 '| cos(theta_thrust) |'             R D=9999.9\n\
CHSEL2_10 'p_t'                              R D=3.0\n\
CHSEL2_11 'Sum of energy inside cones'       R D=-1.\n\
CHSEL2_12 'Sum of energy outside cones'      R D=9999.9\n\
CHSET1_13 'Energy fract in forward region'   R D=9999.9\n\
";

static const Char_t TightLow_guidance[] = 
"cut values for tight low multiplicity selection\n\
>Parameters\n\
CHSET2_1 'Min energy in both hemispheres'    R D=1.0\n\
CHSET2_2 'Max energy in FD'                  R D=2.0\n\
CHSET2_3 'Min number of good charged tracks' R D=2.0\n\
CHSET2_4 'Max number of good charged tracks' R D=8.0\n\
CHSET2_5 'Visible Energy / sqrt(s)'          R D=-1.\n\
CHSET2_6 'Acoplanarity angle'                R D=20.0\n\
CHSET2_7 '| cos(theta_Pmiss) |'              R D=0.9\n\
CHSET2_8 '| cos(theta_jet_max) |'            R D=0.9\n\
CHSET2_9 '| cos(theta_thrust) |'             R D=9999.9\n\
CHSET2_10 'p_t'                              R D=4.0\n\
CHSET2_11 'Sum of energy inside cones'       R D=-1.\n\
CHSET2_12 'Sum of energy outside cones'      R D=5.0\n\
CHSET1_13 'Energy fract in forward region'   R D=9999.9\n\
";

static const Char_t LooseMon_guidance[] = 
"cut values for loose monojet selection\n\
>Parameters\n\
CHSEL3_1 'Min energy in both hemispheres'    R D=1.0\n\
CHSEL3_2 'Max energy in FD'                  R D=2.0\n\
CHSEL3_3 'Min number of good charged tracks' R D=2.0\n\
CHSEL3_4 'Visible Energy / sqrt(s)'          R D=-1.\n\
CHSEL3_5 '| cos(theta_Pmiss) |'              R D=0.9\n\
CHSEL3_6 '| cos(theta_thrust) |'             R D=9999.9\n\
CHSEL3_7 'p_t'                               R D=3.0\n\
CHSEL3_8 'Total invariant Mass'              R D=-1.\n\
CHSET1_9 'Energy fract in forward region'    R D=9999.9\n\
";

static const Char_t TightMon_guidance[] = 
"cut values for tight monojet selection\n\
>Parameters\n\
CHSET3_1 'Min energy in both hemispheres'    R D=1.0\n\
CHSET3_2 'Max energy in FD'                  R D=2.0\n\
CHSET3_3 'Min number of good charged tracks' R D=2.0\n\
CHSET3_4 'Visible Energy / sqrt(s)'          R D=-1.\n\
CHSET3_5 '| cos(theta_Pmiss) |'              R D=0.9\n\
CHSET3_6 '| cos(theta_thrust) |'             R D=0.7\n\
CHSET3_7 'p_t'                               R D=4.0\n\
CHSET3_8 'Total invariant Mass'              R D=2.0.\n\
CHSET1_9 'Energy fract in forward region'    R D=9999.9\n\
";

static const Char_t TightMon_guidance[] = 
"Interactive commands for Central Detector.\n\
";

static const Char_t CVBAT_guidance[] = 
"CV steering routine.\n\
";

static const Char_t CJBAT_guidance[] = 
"CJ steering routine.\n\
";

static const Char_t JCBAT_guidance[] = 
"CJ steering routine.\n\
";

static const Char_t CZBAT_guidance[] = 
"CZ steering routine.\n\
";

static const Char_t CTBAT_guidance[] = 
"CT steering routine.\n\
";

static const Char_t DXBAT_guidance[] = 
"DX steering routine.\n\
";

static const Char_t CXBAT_guidance[] = 
"CX steering routine.\n\
";

static const Char_t CFBAT_guidance[] = 
"CF steering routine.\n\
";

static const Char_t SIBAT_guidance[] = 
"SI steering routine.\n\
";

static const Char_t CSBAT_guidance[] = 
"CS steering routine.\n\
";

static const Char_t CEBAT_guidance[] = 
"CE steering routine.\n\
";

static const Char_t CABAT_guidance[] = 
"CA steering routine.\n\
";

static const Char_t CABAT_guidance[] = 
"Interactive steering of central processors.\n\
";

static const Char_t SHOW_guidance[] = 
"Show selected CENTRAL processes\n\
";

static const Char_t SET_guidance[] = 
"Set selection of CENTRAL processes\n\
";

static const Char_t SET_guidance[] = 
"Interactive commands for Electro-magnetic Calorimeter.\n\
";

static const Char_t TBBAT_guidance[] = 
"TB steering routine.\n\
";

static const Char_t PBBAT_guidance[] = 
"PB steering routine.\n\
";

static const Char_t EBBAT_guidance[] = 
"EB steering routine.\n\
";

static const Char_t PEBAT_guidance[] = 
"PE steering routine.\n\
";

static const Char_t EEBAT_guidance[] = 
"EE steering routine.\n\
";

static const Char_t EMBAT_guidance[] = 
"EM steering routine.\n\
";

static const Char_t EMBAT_guidance[] = 
"Interactive steering of Ecal processors.\n\
";

static const Char_t SHOW_guidance[] = 
"Show selected ECAL processes\n\
";

static const Char_t SET_guidance[] = 
"Set selection of ECAL processes\n\
";

static const Char_t SET_guidance[] = 
"Interactive commands for Hadronic Calorimeter.\n\
";

static const Char_t HBBAT_guidance[] = 
"HB steering routine.\n\
";

static const Char_t HEBAT_guidance[] = 
"HE steering routine.\n\
";

static const Char_t HPBAT_guidance[] = 
"HP steering routine.\n\
";

static const Char_t HMBAT_guidance[] = 
"HM steering routine.\n\
";

static const Char_t HMBAT_guidance[] = 
"Interactive steering of Hcal processors.\n\
";

static const Char_t SHOW_guidance[] = 
"Show selected HCAL processes\n\
";

static const Char_t SET_guidance[] = 
"Set selection of HCAL processes\n\
";

static const Char_t SET_guidance[] = 
"Interactive commands for Muon chamber.\n\
";

static const Char_t MBBAT_guidance[] = 
"MB steering routine.\n\
";

static const Char_t MEBAT_guidance[] = 
"ME steering routine.\n\
";

static const Char_t MMBAT_guidance[] = 
"MM steering routine.\n\
";

static const Char_t MMBAT_guidance[] = 
"Interactive steering of Muon processors.\n\
";

static const Char_t SHOW_guidance[] = 
"Show selected Muon processes\n\
";

static const Char_t SET_guidance[] = 
"Set selection of Muon processes\n\
";

static const Char_t SET_guidance[] = 
"Interactive commands for Forward detector\n\
";

static const Char_t FDBAT_guidance[] = 
"FD steering routine.\n\
";

static const Char_t FDBAT_guidance[] = 
"Interactive steering of Forward processors.\n\
";

static const Char_t SHOW_guidance[] = 
"Show selected Forward processes\n\
";

static const Char_t SET_guidance[] = 
"Set selection of Forward processes\n\
";

static const Char_t SET_guidance[] = 
"ROPE debugging commands.\n\
";

static const Char_t ROSIZE_guidance[] = 
"Print memory size of a ZEBRA bank.\n\
";

static const Char_t DZSNAP_guidance[] = 
"Snap shot of ZEBRA store.\n\
";

static const Char_t DZSURV_guidance[] = 
"Survey of ZEBRA store.\n\
";

static const Char_t DZSHOW_guidance[] = 
"Dump of a ZEBRA bank.\n\
";

static const Char_t DZVERI_guidance[] = 
"Verify ROPE division.\n\
";

static const Char_t SCAN_guidance[] = 
"Set flag for input scan file.\n\
";

static const Char_t NODROP_guidance[] = 
"Set flag to steer XXDROP calls.\n\
";

static const Char_t CONSTANT_guidance[] = 
"Set flag to control writing of constant records.\n\
";

static const Char_t CONSTANT_guidance[] = 
"Commands to get original GOPAL information.\n\
";

static const Char_t ROTREE_guidance[] = 
"Print Kinematics transmitted to ROPE in TREE structure.\n\
";

static const Char_t GOTREE_guidance[] = 
"Print Kinematics transmitted to ROPE in TREE structure.\n\
IT=0: all tracks,\n\
IT<0: print track IT with its  ancestors and descendants\n\
>Parameters\n\
+\n\
IT     'Track number'                I  D=0\n\
";

static const Char_t GOTREE_guidance[] = 
"Cuts for selection of events\n\
";

static const Char_t GET_guidance[] = 
"Get the next event satisfying the cuts set using EVSEL.\n\
";

static const Char_t SHOW_guidance[] = 
"Show cuts / bits for selection of events\n\
>Parameters\n\
EVPAR  'Cut parameter / selection bits'     C  D='BITS' R='ALL,BITS,NCT,EEC,EHC,EV'\n\
";

static const Char_t ENABLE_guidance[] = 
"Enable event selection based on cuts and bits in header words\n\
";

static const Char_t IGNORE_guidance[] = 
"Disable (ignore) selection based on cuts and bits in header words\n\
";

static const Char_t IGNORE_guidance[] = 
"Define cuts/bits for selection of events\n\
";

static const Char_t EVTYPE_guidance[] = 
"Select an event by its Event Type (ROPE)\n\
+SEQ,ROTPARDOC.\n\
>Parameters\n\
OPTION 'Mnemonic for type' C  D='NONE'\n\
-NONE Select by Bit number\n\
-LLLM Low mult presel\n\
-LLQQ High mult veto\n\
-LLCO Cosmic ray veto\n\
-LLIL LL Isolated Lepton\n\
-GAM  Singl phot presel\n\
-HLPT Heavy lept MissE\n\
-HLIS Heavy lept IsolTrk\n\
-TWOP Tagged two phot\n\
-HIGS Higgs high mult\n\
-GSTR Valid single phot\n\
-HLCM Heavy lept Close-m\n\
-TKMH TKMH multihadron\n\
-LLEE Electron pair\n\
-LLMM Muon pair\n\
-LLTT Tau pair\n\
-LLLL Lepton pair\n\
-FYZ1 Phys1 selection\n\
-FYZS Z0 type physics\n\
-FYZT Lumi type physics\n\
-TETR TE stud prescale\n\
-GACE Chgino Gen ACop\n\
-LMAE Chgino LowMul ACop\n\
-MONO Chgino MONOJET\n\
-GOPL GP Chargino\n\
-NELO Neutralino loose\n\
-NETI Neutralino tight\n\
-NELO Neutralino loose\n\
-UGGE Excl. Untag 2gamma\n\
-IUGG Incl. Untag 2gamma\n\
-WABB Wide Angle BhaBha\n\
-L2MH LEP2 MultiHadron\n\
-XXXX unused\n\
-NGAM N-GAMma\n\
-NRH1 Non-rad MH,simple\n\
-NRH2 Non-rad MH,complex\n\
-WW4Q WW ->  qq qq\n\
-WWQE WW ->  qq  e nu\n\
-WWQM WW ->  qq  mu nu\n\
-WWQT WW ->  qq  tau nu\n\
-WWLL WW ->  l nu  l nu\n\
+\n\
IBITNR 'Bit number (if mnemonic NONE)' I D=0 R=-1:64\n\
SETUNS 'Set or unset, BitNr=-1:reset all bits' C D='SET' R='SET,UNSET'\n\
CVETO  'Select or Veto'                C D='Select' R='Select,Veto'\n\
";

static const Char_t FITYPE_guidance[] = 
"Select an event by its Filter Type\n\
>Parameters\n\
CTYPE 'Mnemonic for type' C  D='NONE' R='NONE,-\n\
+\n\
IBITNR 'Bit number (if mnemonic NONE)' I D=0 R=-1:32\n\
SETUNS 'Set or unset'                  C D='SET' R='SET,UNSET'\n\
CVETO  'Select or Veto'                C D='Select' R='Select,Veto'\n\
";

static const Char_t TRWA_guidance[] = 
"Select an event by its trigger bits (97-128)\n\
>Parameters\n\
CTYPE 'Mnemonic for type' C  D='NONE' R='NONE,-\n\
+\n\
IBITNR 'Bit number (if mnemonic NONE)' I D=0 R=-1:32\n\
SETUNS 'Set or unset'                  C D='SET' R='SET,UNSET'\n\
CVETO  'Select or Veto'                C D='Select' R='Select,Veto'\n\
";

static const Char_t TRWB_guidance[] = 
"Select an event by its trigger bits (65-96)\n\
>Parameters\n\
CTYPE 'Mnemonic for type' C  D='NONE' R='NONE,-\n\
+\n\
IBITNR 'Bit number (if mnemonic NONE)' I D=0 R=-1:32\n\
SETUNS 'Set or unset'                  C D='SET' R='SET,UNSET'\n\
CVETO  'Select or Veto'                C D='Select' R='Select,Veto'\n\
";

static const Char_t TRWC_guidance[] = 
"Select an event by its trigger bits (33-64)\n\
>Parameters\n\
CTYPE 'Mnemonic for type' C  D='NONE' R='NONE,-\n\
+\n\
IBITNR 'Bit number (if mnemonic NONE)' I D=0 R=-1:32\n\
SETUNS 'Set or unset'                  C D='SET' R='SET,UNSET'\n\
CVETO  'Select or Veto'                C D='Select' R='Select,Veto'\n\
";

static const Char_t TRWD_guidance[] = 
"Select an event by its trigger bits (1-32)\n\
>Parameters\n\
CTYPE 'Mnemonic for type' C  D='NONE' R='NONE,-\n\
+\n\
IBITNR 'Bit number (if mnemonic NONE)' I D=0 R=-1:32\n\
SETUNS 'Set or unset'                  C D='SET' R='SET,UNSET'\n\
CVETO  'Select or Veto'                C D='Select' R='Select,Veto'\n\
";

static const Char_t NCTRK_guidance[] = 
"Minimum and maximum number of charged tracks\n\
>Parameters\n\
NCMIN  'Minimum number of charged tracks'  I  D=0     R=0:9999\n\
NCMAX  'Maximum number of charged tracks'  I  D=9999  R=0:9999\n\
";

static const Char_t EECAL_guidance[] = 
"Minimum and maximum energy in electromagnetic calorimeters\n\
>Parameters\n\
EEMIN 'Min. energy in electromagnetic calorimeters' R D=0.    R=0.:9999.\n\
EEMAX 'Max. energy in electromagnetic calorimeters' R D=9999. R=0.:9999.\n\
";

static const Char_t EHCAL_guidance[] = 
"Minimum and maximum energy in hadronic calorimeters\n\
>Parameters\n\
EHMIN  'Minimum energy in hadronic calorimeters' R  D=0.    R=0.:9999.\n\
EHMAX  'Maximum energy in hadronic calorimeters' R  D=9999. R=0.:9999.\n\
";

static const Char_t NMUON_guidance[] = 
"Minimum and maximum number of muon segments\n\
>Parameters\n\
NMUMIN 'Minimum number of muon segments' I  D=0     R=0:9999\n\
NMUMAX 'Maximum number of muon segments' I  D=9999  R=0:9999\n\
";

static const Char_t EVENT_guidance[] = 
"Select an event by its trigger number and run number\n\
>Parameters\n\
IEVT 'Trigger number selected (IEVT=0 -> no select)' I D=0 R=0:9999999\n\
+\n\
IRUN 'Run number selected (IRUN=0 -> no selection)' I D=0 R=0:9999999\n\
";

